---
title: 'ARIA: timer role'
slug: Web/Accessibility/ARIA/Roles/ARIA_timer_role
tags:
  - ARIA
  - ARIA Role
  - ARIA widget
  - Reference
  - Role Timer
---
<p>{{draft}}{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">The timer role indicates to assistive technologies that an element is a numerical counter listing the amount of elapsed time from a starting point or the remaining time until an end point.</span></p>

<pre class="brush: html notranslate">&lt;div role="timer" id="eggtimer"&gt;0&lt;/div&gt;
</pre>

<p>This defines this <code>div</code> element as a timer with no remaining time.</p>

<h2 id="Description">Description</h2>

<p>The <code>timer</code> role indicates to assistive technologies that this part of the web content is a live region containing a timer listing the time remaining or elapsed time. A timer's inner text should be an updating current time measurement. While the value does not necessarily need to be machine parsable, it should continuously update at regular intervals unless the timer is paused or reaches its end-point.</p>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<dl>
 <dt>aria-label</dt>
 <dd>Used to provide the name of the timer.</dd>
 <dt>aria-live</dt>
 <dd>Elements with the role <code>timer</code> have an implicit <a class="property-reference" href="https://www.w3.org/TR/wai-aria-1.1/#aria-live"><code>aria-live</code></a> value of <code>off</code>.</dd>
 <dt>aria-describedby</dt>
 <dd>Used to indicate the idref of an element that contains additional instructions for navigating or operating this element.</dd>
 <dt>aria-roledescription</dt>
 <dd>Used to give the timer a more descriptive role text for screen readers to speak. This should be localized.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>Keyboard interaction is XXX. Focus is being managed via <em>XXX</em>.</p>

<p>The <kbd>tab</kbd> , <kbd>Space</kbd> and <kbd>Enter</kbd> keys, as well as <kbd>Escape</kbd> , must be handled by the application. The one exception is if focus XXX.</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<dl>
 <dt>keyPress</dt>
 <dd>Used to handle keyboard input and control the focus</dd>
 <dt>Click, Touch</dt>
 <dd>Handle as appropriate for your widget as well</dd>
 <dt>Changing attribute values</dt>
 <dd><code>aria-activedescendant</code> is used to manage the focus inside the application container. Set in response to keyboard or other application events that change focus or point of interaction.</dd>
</dl>

<div class="note">
<p>The <code>timer</code> role does not have a related HTML widget and XXX. The author of the timer must take full responsibility for not letting users get stuck in a focus limbo or trap focus inside something the user cannot exit of. All aspects of interaction, including returning to the regular web content on other parts of the page, must be handled. Use wisely, and cautiously!</p>
</div>

<h2 id="Examples">Examples</h2>

<p>Some prominent web timers include clocks, stop watches and countdowns, such as ticketing websites, e-commerce sites, and event countdowns (see <a href="https://countingdownto.com/">https://countingdownto.com/</a>).</p>

<p>As an illustration of <code>aria-atomic</code>, consider a site with a simple clock, showing hours and minutes. The clock is updated each minute, with the new remaining time overwriting the current content.</p>

<pre class="brush: html notranslate">&lt;div id="clock" role="timer" aria-live="off"&gt;20&lt;/div&gt;

&lt;button onclick="startTimer('clock')"&gt;start&lt;/button&gt;</pre>

<pre class="brush: js notranslate">/* basic JavaScript to update a timer */
function startTimer(timerName) {
  // get the number of seconds
   let timer = document.getElementById(timerName),
       seconds = parseInt(timer.innerText);
  // remove a second
  // updated the content of timer
   timer.innerText = --seconds
  // if timer != 0, setTimeout
  if (seconds) {
    setTimeout( function() {
      startTimer(timerName);
    }, 1000);
  }
}</pre>

<p>{{EmbedLiveSample("Examples", 600, 130)}}</p>

<p>The first time the function executes, the entirety of the string that is added will be announced. On subsequent calls, only the parts of the content that changed compared to the previous content will be announced. For instance, when the clock changes from "17:33" to "17:34", assistive technologies will only announce "4", which won't be very useful to users.</p>

<p>One way around this would be to first clear the contents of the live region, and then inject the new content. However, this can sometimes be unreliable, as it's dependent on the exact timing of these two updates.</p>

<p><code>aria-atomic="true"</code> ensures that each time the live region is updated, the entirety of the content is announced in full (e.g. "Time: 17:34").</p>

<pre class="notranslate"><code>&lt;div id="clock" role="timer" aria-live="polite" aria-atomic="true"&gt;&lt;/div&gt;</code></pre>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Improperly using the <code>timer</code> role can unintentionally XXX</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#timer","timer")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Precedence_order">Precedence order</h2>

<p>Applying the <code>timer</code> role will cause this and all of the descendant elements of this element to be treated like XXX</p>
